<template>
  <div>
    <h1 class="align_center">Repository Approval Dashboard</h1>

    <SearchSection
      :apiParams="apiParams"
      placeholder="Enter Repo Name (case sensitive)"
    />
     <div class="align_center">
      <el-row :gutter="20">
        <el-col :span="12">
          <GenericPopup
            margin-left="10px"
            :apiParams="apiParams"
            popup="AddProjectPopup"
          />
        </el-col>
        <el-col :span="12">
          <GenericPopup
            margin-left="10px"
            :apiParams="apiParams"
            popup="CreateRepoPopup"
          />
        </el-col>
      </el-row>
    </div>

    <GenericTable table="RepoTable" :apiParams="apiParams" />
  </div>
</template>

<script>
import { mapState } from "vuex";
import GenericPopup from "@/components/popups/GenericPopup.vue";
import GenericTable from "@/components/GenericTable.vue";
import SearchSection from "@/components/SearchSection.vue";

export default {
  data() {
    const url = `/items/repository`;
    const repoFields = [
      "repo_url",
      "repo_name",
      "repo_id",
      "no_of_approvers",
      "approvers.approvers_approvers_id.*",
    ];
    return {
      apiParams: {
        fields: repoFields,
        url,
        searchField: "repo_name",
      },
    };
  },
  computed: {
    ...mapState({
      email: (state) => state.email,
      userId: (state) => state.userId,
    }),
  },
  components: {
    SearchSection,
    GenericPopup,
    GenericTable,
  },
  async mounted() {
    this.$store.commit("SET_LOADING", true);
    (this.apiParams.url = `/items/repository`),
    await new Promise((resolve) => setTimeout(resolve, 100));
    if (document.body.contains(this.$el))
      await this.$store.dispatch("getSearchResults", this.apiParams);
    this.$store.commit("SET_LOADING", false);
  },
  methods: {
    async convertData(data) {
      this.$store.commit("SET_LOADING", false);
      return data;
    },
  },
};
</script>